Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphDataCollector.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphDataCollector.js	(revision 13719)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphDataCollector.js	(revision 13733)
@@ -1,16 +1,27 @@
 ﻿var dataCollection = [];
-
-function initSaveData(id, coll) {//initial data save
-    var temp = dataConversion(coll);
+var taskStatus = {
+    "Offline": "bar-off",
+    "Waiting": "bar-wait",
+    "Transferring": "bar-trans",
+    "Calculating": "bar-calc",
+    "Paused": "bar-paus",
+    "Finished": "bar-fin",
+    "Aborted": "bar-abo",
+    "Failed": "bar-fail"
+}
+
+function initSaveData(id, coll, name) {//initial data save
+    var temp = dataConversion(coll, name);
     temp.unshift(id); //add ID in front of array
     dataCollection.push(temp);// [id,timearr, piearr]
-    console.log("#CREATION: " + id);
-}
-function saveData(id, coll) {
-    var temp = dataConversion(coll);
-    for (var i = 0; i < dataCollection.length; i++) {
-        if (dataCollection[i][0] == id) {
-            dataCollection[i][1] = temp[0];
-            dataCollection[i][2] = temp[1];
+    // console.log("#CREATION: " + id);
+}
+function saveData(id, coll, name) {
+    var temp = dataConversion(coll, name);
+    for (var i = 0; i < dataCollection.length; i++) {
+        if (dataCollection[i][0] == id) {
+            dataCollection[i][1] = temp[0]; // [data,layout]
+            dataCollection[i][2] = temp[1]; // data
+            dataCollection[i][3] = temp[2]; // [tasks, name]
         }
     }
@@ -31,21 +42,69 @@
         }
     }
-
-}
-function dataConversion(coll) {
-    
-    
-    return [dataConversionLine(coll),dataConversionPie(coll)];
-}
-function dataConversionLine(coll) {
+}
+function getDataGantt(id) {
+    for (var i = 0; i < dataCollection.length; i++) {
+        if (dataCollection[i][0] == id) {
+            return dataCollection[i][3];
+        }
+    }
+}
+function dataConversion(coll, name) {
+    var line = dataConversionLine(coll, name);
+    var pie = dataConversionPie(coll);
+    var gantt = dataConversionGantt(coll, name);
+    return [line, pie, gantt];
+}
+function dataConversionGantt(coll, nam) {
+    var tasks = [];
+    for (var v = 0; v < coll.length; v++) {
+
+        var temp = {};
+        temp.startDate = Date.parse(coll[v].DateTime);
+        if (v < coll.length - 1)
+            temp.endDate = Date.parse(coll[v + 1].DateTime);
+        else {
+
+            var dat = Date.parse(coll[v].DateTime);
+            //console.log(dat);
+            temp.endDate = dat + 600000;
+            temp.last = true;
+        }
+        temp.taskName = nam;
+
+        if (coll[v].State == 0)
+            temp.status = "Offline";
+        else if (coll[v].State == 1)
+            temp.status = "Waiting";
+        else if (coll[v].State == 2)
+            temp.status = "Transferring";
+        else if (coll[v].State == 3)
+            temp.status = "Calculating";
+        else if (coll[v].State == 4)
+            temp.status = "Paused";
+        else if (coll[v].State == 5)
+            temp.status = "Finished";
+        else if (coll[v].State == 6)
+            temp.status = "Aborted";
+        else if (coll[v].State == 7)
+            temp.status = "Failed";
+        tasks.push(temp);
+    }
+    return [tasks, nam];
+}
+function dataConversionLine(coll, nam) {
     var xarr = [];
     var yarr = [];
+
     for (var v = 0; v < coll.length; v++) {
+
         xarr.push(Date.parse(coll[v].DateTime));
+        // console.log(xarr[v]);
+        // xarr[v] = xarr[v] - 3600000;
         if (coll[v].State == 1)
             yarr.push("Waiting");
-        else if (coll[v].State == 2) 
+        else if (coll[v].State == 2)
             yarr.push("Transferring");
-        else if (coll[v].State == 3) 
+        else if (coll[v].State == 3)
             yarr.push("Calculating");
         else if (coll[v].State == 5)
@@ -54,4 +113,6 @@
             yarr.push("Failed");
     }
+
+
     var data = [{//Time graph
         x: xarr,
@@ -59,59 +120,36 @@
         type: 'scatter',
         mode: 'lines',
-        name: 'Task ' ,
-        connectgaps:true,
-        line:{shape:'hv'}
+        name: nam,
+        connectgaps: true,
+        line: { shape: 'hvh' }
     }];
-    layout= {
+    layout = {
         "showlegend": true,
         "width": "100%",
         "xaxis": {
-            "autorange": true, 
+            "autorange": true,
             "range": [
-                Date.parse(coll[0].DateTime), 
-                Date.parse(coll[coll.length -1].DateTime)
-            ], 
-            "title": "Time", 
+                Date.parse(coll[0].DateTime),
+                Date.parse(coll[coll.length - 1].DateTime)
+            ],
+            "title": "Time",
             "type": "date"
         }
 
     }
-    
-    return [data,layout];
-}
-function dataConversionHBar(coll) {
-    var xarr = [];
-    var yarr = [];
-    for (var v = 0; v < coll.length; v++) {
-        xarr.push(coll[v].DateTime.substr(11, 8));
-        if (coll[v].State == 1)
-            yarr.push("Waiting");
-        else if (coll[v].State == 2) 
-            yarr.push("Transferring");
-        else if (coll[v].State == 3) 
-            yarr.push("Calculating");
-        else if (coll[v].State == 5)
-            yarr.push("Finished");
-        else if (coll[v].State == 7)
-            yarr.push("Failed");
-    }
-    var data = [{//Time graph
-        x: xarr,
-        y: yarr,
-        type: 'scatter'
-    }];
-    
-    return data;
-}
+
+    return [data, layout];
+}
+
 function dataConversionPie(coll) {
     var waiting = 0;
     var transfer = 0;
     var calc = 0;
-    for (var v = 0; v < coll.length-1; v++) {
-        if(coll[v].State == 1)
+    for (var v = 0; v < coll.length - 1; v++) {
+        if (coll[v].State == 1)
             waiting += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
-        else if (coll[v].State == 2) 
+        else if (coll[v].State == 2)
             transfer += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
-        else if (coll[v].State == 3) 
+        else if (coll[v].State == 3)
             calc += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
     }
@@ -133,9 +171,27 @@
     document.getElementById("graph" + val).style.width = "100%";
     document.getElementById("graph" + val).style.height = "400px";
+    document.getElementById("graph" + val).innerHTML = "";
+    document.getElementById("graph" + val).style.marginLeft = "0px";
     if (document.getElementById("graphtoggle" + val).checked) {
         setTimeout(function () {
+
+            var temp = getDataGantt(val);
+            var w = $("#graph" + val).parent().width() - 30;
+            document.getElementById("graph" + val).style.height = "200px";
+            var gantt = d3.gantt().selector('#graph' + val).height('200').width(w).margin({
+                top: 20,
+                right: 40,
+                bottom: 20,
+                left: 20
+            }).drawytitles(false).taskTypes([temp[1]]).taskStatus(taskStatus);
+            //    document.getElementById("graph" + val).style.marginLeft = "-40px";
+            gantt(temp[0]);
+        }, 100);
+
+
+        /* setTimeout(function () {
             Plotly.newPlot('graph' + val, getData(val)[0], getData(val)[1]);
-        }, 100);
-        console.log("#REDRAWN LINE: " + val);
+        }, 100);*/
+        // console.log("#REDRAWN LINE: " + val);
     } else {
         setTimeout(function () {
@@ -144,8 +200,31 @@
         //console.log("#REDRAWN PIE: " + val);
     }
-    
+
 
 }
 function redrawMain() {
+    document.getElementById("graphMain").innerHTML = "";
+
+    var tempdata = [];
+    var tempnames = [];
+    for (var i = 0; i < dataCollection.length; i++) {
+        var t = dataCollection[i][3][0].slice();
+        var name =  t[0].taskName.substring(0, 5) + " | " + i + ":";
+
+        for (var v = 0; v < t.length; v++) {
+            t[v].taskName = name;
+        }
+        tempdata = tempdata.concat(t);
+        tempnames = tempnames.concat(name)
+    }
+    var h = (tempnames.length * 20) + 100;
+    document.getElementById("graphMain").style.height = h + "px";
+
+    var w = $("#graphMain").parent().width() - 100;
+
+    var gantt = d3.gantt().selector("#graphMain").height(h - 50).width(w).taskTypes(tempnames).taskStatus(taskStatus);
+    document.getElementById("graphMain").style.marginLeft = "20px";
+    gantt(tempdata);
+    /* LINE VERSION
     var temp = [];
     var min = dataCollection[0][1][0][0].x[0];
@@ -173,5 +252,5 @@
     }
      Plotly.newPlot('graphMain', temp, layout);
-
-
-}
+     */
+
+}
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphHubber.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphHubber.js	(revision 13719)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphHubber.js	(revision 13733)
@@ -5,29 +5,64 @@
     $.connection.hub.start().done(function () {
         hubber.server.initConnection();
-        hubber.server.updateAll();
+        // hubber.server.updateAll();
         redrawMain();
     });
-    hubber.client.processData = function (id, data) {
+    hubber.client.processData = function (id, data, name) {
         var obj = JSON.parse(data);
+        
         editTaskData(id, obj);
-        saveData(id, obj.StateLog);
+        //console.log(name);
+        saveData(id, obj.StateLog, name);
+        console.log("#UPDATED " + id);
+    }
+    hubber.client.processJobData = function (calc, fin) {
+        editJobData(calc, fin);
     }
     hubber.client.requestDone = function () {
-        
-        setTimeout(function () {
-            hubber.server.updateAll();
-            console.log("#REFRESH ALL");
-            
-        }, 5000);
+        if (document.getElementById("refreshtogg").checked) {
+            setTimeout(function () {
+                hubber.server.updateAll();
+                console.log("#REFRESH ALL");
+
+            }, 5000);
+        }
     }
     //hubber.c
 })
 
+function autoRefresh() {
+    if (document.getElementById("refreshtogg").checked)
+        hubber.server.updateAll();
+
+}
+function restart(id) {
+    document.getElementById("restarterbtn" + id).disabled = true;
+    document.getElementById("restarterbtn" + id).value = "Sending restart request...";
+    hubber.server.restartTask(id);
+}
+function editJobData(c, f) {
+    $("#jobcalculating").html("Calculating: " + c);
+    $("#jobfinished").html("Finished: " + f);
+}
+
 function editTaskData(id, task) {
     //lastupdate
-    var dat = new Date(task.LastHeartbeat);
-    $("#lastupdpar" + id).html("Last update: " + dat.toUTCString());
+    if (task.LastHeartbeat != null) {
+        var dat = new Date(task.LastHeartbeat);
+        $("#lastupdpar" + id).html("Last update: " + dat.toUTCString());
+    }
+    else
+        $("#lastupdpar" + id).html("No updates yet");
+    //task restarter
+    document.getElementById("restarter" + id).style.display = "none";
     //state
-    if (task.State == "1") {
+    if (task.State == "0") {
+        $("#statepar" + id).css({
+            'color': 'gray',
+            'font-weight': 'normal'
+        });
+        $("#statepar" + id).html("State: Offline");
+    }
+    else if (task.State == "1") {
         $("#statepar" + id).css({
             'color': 'white',
@@ -39,5 +74,6 @@
         $("#statepar" + id).css({
             'color': 'white',
-            'font-weight': 'normal'
+            'font-weight': 'normal',
+            'text-shadow': '2px 2px black'
         });
         $("#statepar" + id).html("State: Transferring");
@@ -50,25 +86,85 @@
         $("#statepar" + id).html("State: Calculating");
     }
+    else if (task.State == "4") {
+        $("#statepar" + id).css({
+            'color': 'white',
+            'font-weight': 'normal'
+        });
+        $("#statepar" + id).html("State: Paused");
+        document.getElementById("restarter" + id).style.display = "";
+        document.getElementById("restarterbtn" + id).disabled = false;
+        document.getElementById("restarterbtn" + id).value = "Restart task";
+    }
     else if (task.State == "5") {
         $("#statepar" + id).css({
             'color': '#009900',
-            'font-weight': '900'
+            'font-weight': '900',
+            'text-shadow': '1px 1px black'
         });
         $("#statepar" + id).html("State: Finished");
-        var datf = new Date(task.StateLog[task.StateLog.length -1].DateTime);
+        var datf = new Date(task.StateLog[task.StateLog.length - 1].DateTime);
         $("#lastupdpar" + id).html("Finished: " + datf.toUTCString());
+    }
+    else if (task.State == "6") {
+        $("#statepar" + id).css({
+            'color': '#e60000',
+            'font-weight': '900',
+            'text-shadow': '1px 1px black'
+        });
+        $("#statepar" + id).html("State: Aborted");
+
+        document.getElementById("restarter" + id).style.display = "";
+        document.getElementById("restarterbtn" + id).disabled = false;
+        document.getElementById("restarterbtn" + id).value = "Restart task";
     }
     else if (task.State == "7") {
         $("#statepar" + id).css({
-            'color': '#df2020',
-            'font-weight': '900'
+            'color': '#e60000',
+            'font-weight': '900',
+            'text-shadow': '1px 1px black'
         });
         $("#statepar" + id).html("State: Failed");
+
+        document.getElementById("restarter" + id).style.display = "";
+        document.getElementById("restarterbtn" + id).disabled = false;
+        document.getElementById("restarterbtn" + id).value = "Restart task";
     }
-    
+
     //execution time
     $("#executionpar" + id).html(task.ExecutionTime + " executed");
+    //exception
+    if (task.StateLog[task.StateLog.length - 1].Exception != null)
+        if (task.StateLog[task.StateLog.length - 1].Exception != "") {
+            $("#exceptionpar" + id).html("Exception: " + task.StateLog[task.StateLog.length - 1].Exception)
+            $("#exceptionpar" + id).css({
+                'color': '#e60000',
+                'font-weight': '700',
+                'text-shadow': '1px 1px black'
+            });
+        }
+        else if (task.State == "6") {
+            $("#exceptionpar" + id).html("Task is aborted.")
+            $("#exceptionpar" + id).css({
+                'color': '#e65c00',
+                'font-weight': '700',
+                'text-shadow': '1px 1px black'
+            });
+        }
+        else {
+            $("#exceptionpar" + id).html("No exceptions");
+            $("#exceptionpar" + id).css({
+                'color': 'white',
+                'text-shadow': '2px 2px black'
+            });
+        }
+    else {
+        $("#exceptionpar" + id).html("No exceptions");
+        $("#exceptionpar" + id).css({
+            'color': 'white',
+            'text-shadow': '2px 2px black'
+        });
+    }
     //state changes
-    $("#statechangespar" + id).html("Statelogs: "+task.StateLog.length);
+    $("#statechangespar" + id).html("Statelogs: " + task.StateLog.length);
     //graph title
     var dat1 = new Date(task.StateLog[0].DateTime);
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/hubber.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/hubber.js	(revision 13719)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/hubber.js	(revision 13733)
@@ -22,5 +22,5 @@
 function addtoHive() {
 
-    var jobname = prompt("Please enter a job name", "Job");
+    var jobname = document.getElementById("jname").value;
     if (jobname && jobname != "" && jobname != null) {
         hubber.server.changeName(jobname);
@@ -29,4 +29,6 @@
         document.getElementById("result").style.display = "";
         document.getElementById("realhiveadd").click();
+    } else {
+        alert("Job name not set!");
     }
 }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/d3-gantt-jobstatus.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/d3-gantt-jobstatus.js	(revision 13733)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/d3-gantt-jobstatus.js	(revision 13733)
@@ -0,0 +1,316 @@
+/**
+ * @Orignal author Dimitry Kudrayvtsev
+ * @version 2.1
+
+  * Rewritten for Hive Web Job Manager
+ */
+
+d3.gantt = function () {
+    var FIT_TIME_DOMAIN_MODE = "fit";
+    var FIXED_TIME_DOMAIN_MODE = "fixed";
+
+    var margin = {
+        top: 20,
+        right: 40,
+        bottom: 20,
+        left: 70
+    };
+    var drawytitles = true;
+    var selector = 'body';
+    var timeDomainStart = d3.time.day.offset(new Date(), -3);
+    var zoomStart;
+    var zoomEnd;
+    var timeDomainEnd = d3.time.hour.offset(new Date(), +3);
+    var timeDomainMode = FIT_TIME_DOMAIN_MODE;// fixed or fit
+    var taskTypes = [];
+    var taskStatus = [];
+    var height = document.body.clientHeight - margin.top - margin.bottom - 5;
+    var width = document.body.clientWidth - margin.right - margin.left - 5;
+
+    var tickFormat = "%H:%M";
+
+    var keyFunction = function (d) {
+        return d.startDate + d.taskName + d.endDate;
+    };
+
+    var rectTransform = function (d) {
+        return "translate(" + x(d.startDate - 3600000) + "," + y(d.taskName) + ")";
+    };
+
+    var x = d3.time.scale().domain([timeDomainStart, timeDomainEnd]).range([0, width]).clamp(true);
+
+    var y = d3.scale.ordinal().domain(taskTypes).rangeRoundBands([0, height - margin.top - margin.bottom], .1);
+
+    var xAxis = d3.svg.axis().scale(x).orient("bottom").tickFormat(d3.time.format(tickFormat)).tickSubdivide(true)
+	    .tickSize(8).tickPadding(8);
+
+    var yAxis = d3.svg.axis().scale(y).orient("left").tickSize(0);
+
+    var initTimeDomain = function (tasks) {
+        if (timeDomainMode === FIT_TIME_DOMAIN_MODE) {
+            if (tasks === undefined || tasks.length < 1) {
+                timeDomainStart = d3.time.day.offset(new Date(), -3);
+                timeDomainEnd = d3.time.hour.offset(new Date(), +3);
+                return;
+            }
+            tasks.sort(function (a, b) {
+                return a.endDate - b.endDate;
+            });
+            timeDomainEnd = tasks[tasks.length - 1].endDate;
+            tasks.sort(function (a, b) {
+                return a.startDate - b.startDate;
+            });
+            timeDomainStart = tasks[0].startDate;
+        }
+    };
+
+    var initAxis = function () {
+        x = d3.time.scale().domain([timeDomainStart - 3600000, timeDomainEnd - 3600000]).range([0, width]).clamp(true);
+        y = d3.scale.ordinal().domain(taskTypes).rangeRoundBands([0, height - margin.top - margin.bottom], .1);
+        if (new Date(timeDomainStart).toDateString() != new Date(timeDomainEnd).toDateString()) {
+            xAxis = d3.svg.axis().scale(x).orient("bottom").tickFormat(null).tickSubdivide(true)
+            .tickSize(8).tickPadding(8);
+        }
+        else
+            xAxis = d3.svg.axis().scale(x).orient("bottom").tickFormat(d3.time.format(tickFormat)).tickSubdivide(true)
+            .tickSize(8).tickPadding(8);
+
+
+        yAxis = d3.svg.axis().scale(y).orient("left").tickSize(0);
+    };
+
+    function gantt(tasks) {
+
+        initTimeDomain(tasks);
+        initAxis();
+
+        var tip = d3.tip()
+            .attr('class', 'd3-tip')
+            .html(function (d) {
+                var start = new Date(d.startDate);
+                var end = new Date(d.endDate);
+                var stat = d.status;
+                if (d.last) {
+                    return stat + " <br/> " + start.toUTCString() + " to now";
+                }
+                return stat + " <br/> " + start.toUTCString() + " to " + end.toUTCString();
+            });
+
+
+        var svgitself = d3.select(selector)
+       .append("svg")
+       .attr("class", "chart")
+       .attr("width", "100%")
+       .attr("height", height + margin.top + margin.bottom)
+        var svg = svgitself.append("g")
+           .attr("class", "gantt-chart")
+       .attr("width", "100%")
+       .attr("height", height + margin.top + margin.bottom)
+       .attr("transform", "translate(" + margin.left + ", " + margin.top + ")")
+        .call(tip);
+
+
+
+
+        svg.selectAll(".chart")
+       .data(tasks, keyFunction).enter()
+       .append("rect")
+       .attr("rx", 5)
+           .attr("ry", 5)
+       .attr("class", function (d) {
+           if (taskStatus[d.status] == null) { return "bar"; }
+           return taskStatus[d.status];
+       })
+       .attr("y", 0)
+       .attr("transform", rectTransform)
+       .attr("height", function (d) { return y.rangeBand(); })
+       .attr("width", function (d) {
+           return (x(d.endDate - 3600000) - x(d.startDate - 3600000));
+       })
+       .on('mouseover', tip.show)
+        .on('mouseout', tip.hide);
+
+
+
+
+
+
+        svg.append("g")
+        .attr("class", "x axis")
+        .attr("transform", "translate(0, " + (height - margin.top - margin.bottom) + ")")
+        .transition()
+        .call(xAxis);
+
+        if (drawytitles)
+            svg.append("g")
+                .attr("class", "y axis")
+                //.attr("transform", "translate(" + ((width / 2)) + "," + (-(height / 2) + margin.top) + " )")
+                .transition()
+                .call(yAxis);
+
+        svgitself.on("mousedown", function () {
+            
+            var p = d3.mouse(this);
+            var w = width;
+            w =  (p[0])/w;
+            gantt.zoom(tasks, w, this);
+        })
+        .on("contextmenu", function (d, i) {
+            zoomStart = null;
+            d3.event.preventDefault();
+            gantt.redraw(tasks, this);
+    });
+
+    return gantt;
+
+};
+    gantt.zoom = function (tasks, xcor, el) {
+      
+    initTimeDomain(tasks);
+    if (zoomStart == null) {
+        zoomStart = timeDomainStart;
+        zoomEnd = timeDomainEnd;
+    }
+    var diff = zoomEnd - zoomStart;
+    var cent = (diff * xcor) + zoomStart;
+    var piece = diff / 1.5;
+        
+    var tempstart = cent - (piece / 2);
+    piece = piece /2;
+    if (tempstart < zoomStart) {
+        piece += zoomStart - tempstart;
+    } else
+        zoomStart = tempstart;
+
+    var tempend = cent + piece;
+    if (tempend > zoomEnd)
+        zoomStart -= tempend - zoomEnd;
+    else
+        zoomEnd = tempend;
+
+    timeDomainStart = zoomStart;
+    timeDomainEnd = zoomEnd;
+    gantt.redrawInner(tasks, el);
+}
+
+gantt.redraw = function(tasks, el){
+    initTimeDomain(tasks);
+    gantt.redrawInner(tasks, el);
+}
+
+gantt.redrawInner= function (tasks, el) {
+        
+    initAxis();
+
+    var svg = d3.select(el);
+
+    var ganttChartGroup = svg.select(".gantt-chart");
+    var rect = ganttChartGroup.selectAll("rect").data(tasks, keyFunction);
+
+    rect.enter()
+     .insert("rect", ":first-child")
+     .attr("rx", 5)
+     .attr("ry", 5)
+ .attr("class", function (d) {
+     if (taskStatus[d.status] == null) { return "bar"; }
+     return taskStatus[d.status];
+ })
+ .transition()
+ .attr("y", 0)
+ .attr("transform", rectTransform)
+ .attr("height", function (d) { return y.rangeBand(); })
+ .attr("width", function (d) {
+     return (x(d.endDate - 3600000) - x(d.startDate - 3600000));
+ });
+
+    rect.transition()
+      .attr("transform", rectTransform)
+ .attr("height", function (d) { return y.rangeBand(); })
+ .attr("width", function (d) {
+     return (x(d.endDate - 3600000) - x(d.startDate - 3600000));
+ });
+
+    rect.exit().remove();
+
+    svg.select(".x").transition().call(xAxis);
+    svg.select(".y").transition().call(yAxis);
+
+    return gantt;
+};
+
+gantt.margin = function (value) {
+    if (!arguments.length)
+        return margin;
+    margin = value;
+    return gantt;
+};
+gantt.drawytitles = function (value) {
+    if (!arguments.length)
+        return drawytitles;
+    drawytitles = value;
+    return gantt;
+}
+gantt.timeDomain = function (value) {
+    if (!arguments.length)
+        return [timeDomainStart, timeDomainEnd];
+    timeDomainStart = +value[0], timeDomainEnd = +value[1];
+    return gantt;
+};
+
+/**
+ * @param {string}
+ *                vale The value can be "fit" - the domain fits the data or
+ *                "fixed" - fixed domain.
+ */
+gantt.timeDomainMode = function (value) {
+    if (!arguments.length)
+        return timeDomainMode;
+    timeDomainMode = value;
+    return gantt;
+
+};
+
+gantt.taskTypes = function (value) {
+    if (!arguments.length)
+        return taskTypes;
+    taskTypes = value;
+    return gantt;
+};
+
+gantt.taskStatus = function (value) {
+    if (!arguments.length)
+        return taskStatus;
+    taskStatus = value;
+    return gantt;
+};
+
+gantt.width = function (value) {
+    if (!arguments.length)
+        return width;
+    width = +value;
+    return gantt;
+};
+
+gantt.height = function (value) {
+    if (!arguments.length)
+        return height;
+    height = +value;
+    return gantt;
+};
+
+gantt.tickFormat = function (value) {
+    if (!arguments.length)
+        return tickFormat;
+    tickFormat = value;
+    return gantt;
+};
+
+gantt.selector = function (value) {
+    if (!arguments.length)
+        return selector;
+    selector = value;
+    return gantt;
+};
+
+return gantt;
+};
